- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members
IterableDigraphComponent< BAS > Class Template Reference

## Detailed Description

### template<typename BAS = BaseDigraphComponent>
class lemon::concepts::IterableDigraphComponent< BAS >

This class describes the interface of iterable directed graphs. It extends BaseDigraphComponent with the core iterable interface. This concept is part of the Digraph concept.

`#include <lemon/concepts/graph_components.h>`

Inheritance diagram for IterableDigraphComponent< BAS >:
[legend]

## Class Based Iteration
This interface provides iterator classes for digraph items.
typedef GraphItemIt< Digraph, Node > | NodeIt
| This iterator goes through each node. More...
typedef GraphItemIt< Digraph, Arc > | ArcIt
| This iterator goes through each arc. More...
typedef GraphIncIt< Digraph, Arc, Node, 'i'> | InArcIt
| This iterator goes trough the incoming arcs of a node. More...
typedef GraphIncIt< Digraph, Arc, Node, 'o'> | OutArcIt
| This iterator goes trough the outgoing arcs of a node. More...
Node | baseNode (const InArcIt &) const
| The base node of the iterator. More...
Node | runningNode (const InArcIt &) const
| The running node of the iterator. More...
Node | baseNode (const OutArcIt &) const
| The base node of the iterator. More...
Node | runningNode (const OutArcIt &) const
| The running node of the iterator. More...

## Public Member Functions
Base Iteration
This interface provides functions for iteration on digraph items.
void | first (Node &) const
| Return the first node. More...
void | next (Node &) const
| Return the next node. More...
void | first (Arc &) const
| Return the first arc. More...
void | next (Arc &) const
| Return the next arc. More...
void | firstIn (Arc &, const Node &) const
| Return the first arc incoming to the given node. More...
void | nextIn (Arc &) const
| Return the next arc incoming to the given node. More...
void | firstOut (Arc &, const Node &) const
| Return the first arc outgoing form the given node. More...
void | nextOut (Arc &) const
| Return the next arc outgoing form the given node. More...

## Member Typedef Documentation

typedef GraphItemIt<Digraph, Node> NodeIt

This iterator goes through each node.

typedef GraphItemIt<Digraph, Arc> ArcIt

This iterator goes through each arc.

typedef GraphIncIt<Digraph, Arc, Node, 'i'> InArcIt

This iterator goes trough the incoming arcs of a certain node of a digraph.

typedef GraphIncIt<Digraph, Arc, Node, 'o'> OutArcIt

This iterator goes trough the outgoing arcs of a certain node of a digraph.

## Member Function Documentation

void first | ( | Node & |  | ) | const
| inline

This function gives back the first node in the iteration order.

void next | ( | Node & |  | ) | const
| inline

This function gives back the next node in the iteration order.

void first | ( | Arc & |  | ) | const
| inline

This function gives back the first arc in the iteration order.

void next | ( | Arc & |  | ) | const
| inline

This function gives back the next arc in the iteration order.

void firstIn | ( | Arc & | ,
|  | const Node & |
| ) |  | const
| inline

This function gives back the first arc incoming to the given node.

void nextIn | ( | Arc & |  | ) | const
| inline

This function gives back the next arc incoming to the given node.

void firstOut | ( | Arc & | ,
|  | const Node & |
| ) |  | const
| inline

This function gives back the first arc outgoing form the given node.

void nextOut | ( | Arc & |  | ) | const
| inline

This function gives back the next arc outgoing form the given node.

Node baseNode | ( | const InArcIt & |  | ) | const
| inline

This function gives back the base node of the iterator. It is always the target node of the pointed arc.

Node runningNode | ( | const InArcIt & |  | ) | const
| inline

This function gives back the running node of the iterator. It is always the source node of the pointed arc.

Node baseNode | ( | const OutArcIt & |  | ) | const
| inline

This function gives back the base node of the iterator. It is always the source node of the pointed arc.

Node runningNode | ( | const OutArcIt & |  | ) | const
| inline

This function gives back the running node of the iterator. It is always the target node of the pointed arc.